// Code generated by go-swagger; DO NOT EDIT.

package version_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new version service API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for version service API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	VersionServiceApply(params *VersionServiceApplyParams) (*VersionServiceApplyOK, error)

	VersionServiceOperator(params *VersionServiceOperatorParams) (*VersionServiceOperatorOK, error)

	VersionServiceProduct(params *VersionServiceProductParams) (*VersionServiceProductOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  VersionServiceApply specifics version

  Return specific product version
*/
func (a *Client) VersionServiceApply(params *VersionServiceApplyParams) (*VersionServiceApplyOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewVersionServiceApplyParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "VersionService_Apply",
		Method:             "GET",
		PathPattern:        "/versions/v1/{product}/{operatorVersion}/{apply}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &VersionServiceApplyReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*VersionServiceApplyOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*VersionServiceApplyDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  VersionServiceOperator products versions for specific operator version

  Return product versions for specific operator
*/
func (a *Client) VersionServiceOperator(params *VersionServiceOperatorParams) (*VersionServiceOperatorOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewVersionServiceOperatorParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "VersionService_Operator",
		Method:             "GET",
		PathPattern:        "/versions/v1/{product}/{operatorVersion}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &VersionServiceOperatorReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*VersionServiceOperatorOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*VersionServiceOperatorDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  VersionServiceProduct products versions for all operator version

  Return product versions for all operator
*/
func (a *Client) VersionServiceProduct(params *VersionServiceProductParams) (*VersionServiceProductOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewVersionServiceProductParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "VersionService_Product",
		Method:             "GET",
		PathPattern:        "/versions/v1/{product}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &VersionServiceProductReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*VersionServiceProductOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*VersionServiceProductDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
